package de.ozgcloud.eingang.xta.zip;

import java.io.IOException;
import java.io.InputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import de.ozgcloud.eingang.common.errorhandling.TechnicalException;
import lombok.Builder;

@Builder
record ReadableZipEntry(ZipEntry zipEntry, ZipFile parentZip) {
	public InputStream getInputStream() throws IOException {
		return parentZip.getInputStream(zipEntry);
	}

	public Long getPositiveSize() {
		var size = zipEntry.getSize();
		if (size < 0) {
			throw new TechnicalException("Size of ZIP entry is unknown.");
		}
		return size;
	}

	public String getName() {
		return zipEntry.getName();
	}
}
